/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)getpass.c	based on 5.3 (Berkeley) 9/22/88";
#endif /* LIBC_SCCS and not lint */

#include <stdio.h>
#include <fcntl.h>
#ifdef __SASC
#include <ios1.h>
#endif

char *
getpass(prompt)
	char *prompt;
{
	register int ch;
	register char *p;
	FILE *fp, *outfp;
#define	PASSWD_LEN	128
	static char buf[PASSWD_LEN + 1];

	/*
	 * read and write to /dev/tty if possible; else read from
	 * stdin and write to stderr.
	 */
	outfp = stdout;
	fp = stdin;

#ifdef __SASC
    SetMode(chkufb(fileno(fp))->ufbfh,1L);
#else
    SetMode(_devtab[fileno(fp)].fd,1L);
#endif
	fputs(prompt, outfp);
	fflush(outfp);
	for (p = buf; (ch = getc(fp)) != EOF && ch != '\r';)
		if (p < buf + PASSWD_LEN)
			*p++ = ch;
	*p = '\0';
	(void)write(fileno(outfp), "\n", 1);

#ifdef __SASC
    SetMode(chkufb(fileno(fp))->ufbfh,0L);
#else
    SetMode(_devtab[fileno(fp)].fd,0L);
#endif

	return(buf);
}

